// READ CD SECTORS
// http://support.microsoft.com/support/kb/articles/Q138/4/34.asp

#include <windows.h>
#include <stdio.h>	// for printf
#include <winioctl.h>  	// for CTL_CODE, FILE_READ_ACCESS, METHOD_BUFFERED, FILE_DEVICE_CDROM, DISK_GEOMETRY
#include <ntddcdrm.h>	// drive:\ntddk\inc\ntddcdrm.h for IOCTL_STORAGE_MEDIA_REMOVAL in the called header file ntddstor.h which replaces IOCTL_CDROM_MEDIA_REMOVAL, IOCTL_GET_DRIVE_GEOMETRY

//*************************************************************************
//*************************** DECLARE VARIABLES ***************************
//*************************************************************************

	LPBYTE lpSector;
	HANDLE handle_CD, handle_File;
	DWORD dwJunk;
	DISK_GEOMETRY dgCDROM;
	PREVENT_MEDIA_REMOVAL pmrLockCDROM;
	int sector_number, test;
	char drive_letter[6]={'\\','\\','.','\\',' ',':'};

//*************************************************************************
//******************************* PROCEDURES ******************************
//*************************************************************************

// GET HANDLE TO CD DRIVE
ULONG Get_Handle_To_CD(){
	printf("\n\n     Enter your CD drive letter: ");
	scanf("%c", &drive_letter[4]);
	fflush(stdin);
      handle_CD = CreateFile (drive_letter, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	return 0;}

// LOCK CD DRIVE
ULONG Lock_CD_Drive(){
	pmrLockCDROM.PreventMediaRemoval = TRUE;
	DeviceIoControl (handle_CD, IOCTL_STORAGE_MEDIA_REMOVAL, &pmrLockCDROM, sizeof(pmrLockCDROM), NULL, 0, &dwJunk, NULL);
	return 0;}

// CREATE SECTOR FILE
ULONG Create_Sector_File(){
      handle_File = CreateFile ("roak.nog", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	return 0;}

// READ THREE SECTORS OF CD & WRITE THREE SECTORS TO FILE
ULONG Read_CD_Write_File(){
	if (ReadFile (handle_CD, lpSector, 3 * dgCDROM.BytesPerSector, &dwJunk, NULL))
	test = WriteFile (handle_File, lpSector, 3 * dgCDROM.BytesPerSector, &dwJunk, NULL);
	return test;}

// UNLOCK CD DRIVE
ULONG Unlock_CD_Drive(){
	pmrLockCDROM.PreventMediaRemoval = FALSE;
	DeviceIoControl (handle_CD, IOCTL_CDROM_MEDIA_REMOVAL, &pmrLockCDROM, sizeof(pmrLockCDROM), NULL, 0, &dwJunk, NULL);
	return 0;}

//*************************************************************************
//************************************ MAIN *******************************
//*************************************************************************
__cdecl main(){
// INPUT FIRST OF THREE SECTORS TO READ
	printf("\n\n     This program reads three consecutive sectors of a CD.\n\n\n     Enter the first CD sector number you wish to read: ");
	scanf("%i",&sector_number);
	fflush(stdin);
// CREATE SECTOR FILE
	Create_Sector_File();
// GET HANDLE TO CD DRIVE
	Get_Handle_To_CD();
// PROCEED IF YOU HAVE CD HANDLE
      if (handle_CD != INVALID_HANDLE_VALUE){
// LOCK CD DRIVE
	Lock_CD_Drive();
// GET SIZE OF CD SECTOR
	if (DeviceIoControl (handle_CD, IOCTL_CDROM_GET_DRIVE_GEOMETRY, NULL, 0, &dgCDROM, sizeof(dgCDROM), &dwJunk, NULL)){
// ALLOCATE MEMORY FOR THREE SECTORS
	lpSector = VirtualAlloc (NULL, 3 * dgCDROM.BytesPerSector, MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
// MOVE TO SECTOR IN SO-CALLED FILE OF CD
	SetFilePointer (handle_CD, dgCDROM.BytesPerSector * sector_number, NULL, FILE_BEGIN);
// READ THREE SECTORS OF CD & WRITE THREE SECTORS TO FILE
	Read_CD_Write_File();
// RELEASE PAGES OF MEMORY FOR THREE SECTORS
	VirtualFree (lpSector, 0, MEM_RELEASE);}
// UNLOCK CD DRIVE
	Unlock_CD_Drive();
// CLOSE HANDLES
	CloseHandle (handle_CD);
	CloseHandle (handle_File);
// FINAL MESSAGE
	if (test != 0)printf("\n\n     The bytes from the three CD sectors were\n     written to the file roak.nog.\n\n");
	else printf("\n\n     Error!  Do you have a CD in your drive?\n     Do you have the right drive letter?\n\n");
	printf("\n\n     Freehafer's Read CD Sectors Program is terminated!\n\n     (c)2002 INNIEA PUBLISHING COMPANY! R%c%cK NOG!\n\n", (char)153, (char)142);
	getchar();}}
